

#define LED_PORT	GPIOB
#define LED1		GPIO_Pin_1
#define LED2		GPIO_Pin_2
#define JOY_OK		GPIO_Pin_5

#define JOY_PORT	GPIOC
#define JOY_U		GPIO_Pin_0
#define JOY_D		GPIO_Pin_1
#define JOY_L		GPIO_Pin_2
#define JOY_R		GPIO_Pin_3



#define NO_KEY		0
#define KEY_DN		1
#define KEY_UP		2
#define KEY_L		3
#define KEY_R		4
#define KEY_OK		5

#define ADC1_DR_Address    ((uint32_t)0x4001244C)
#define TIM1_CCR1_Address   ((uint32_t)0x40012C34)

#include <stddef.h>
#include "stm32f10x.h"
#include <stdio.h>
#include "nokia_lcd.h"
#include "menu.h"

#ifdef __GNUC__
  /* With GCC/RAISONANCE, small printf (option LD Linker->Libraries->Small printf
     set to 'Yes') calls __io_putchar() */
  #define PUTCHAR_PROTOTYPE int __io_putchar(int ch)
#else
  #define PUTCHAR_PROTOTYPE int fputc(int ch, FILE *f)
#endif /* __GNUC__ */

void init(void);					// inicjalizacja procesora
void RCC_Conf(void);				// inicjalizacja zegara
void SysTick_Conf(void);			// inicjalizacja zegara SysTick
void EXTI_Conf(void);				// inicjalizacja przerwan zewnetrznych
void NVIC_Conf(void);				// iicjalizacja kontrolera przerwan
void Tim_Conf(void);				// inicjalizacja timerow
void GPIO_Conf(void);				// inicjalizacja portow
void USART_Conf(void);
void ADC_Conf(void);				// inicjalizacja ADC
void DMA_Conf(void);				// inicjalizacja DMA
void delay_ms(uint32_t time);					// opoznienie
int getkey(void);


void send_str(uint8_t *str);
void send_chr(uint8_t chr);

uint8_t stan_led2, stan_led1;

TIM_OCInitTypeDef  TIM_OCInitStructure;
TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;

uint32_t inc;
uint32_t increment_delay=500000;	// opoznienie zalaczenia autopowtarzania przyciskow
uint32_t auto_repeat_period=50;		// czestotliwosc autopowtarzania przyciskow (w ms)



uint32_t TDelay;

__IO int16_t bklt_level = 5;

ADC_InitTypeDef ADC_InitStructure;
DMA_InitTypeDef DMA_InitStructure;
__IO uint16_t ADCConvertedValue;
__IO uint16_t ADCVal[2];

int main(void)
{
  int i = 0;
  uint32_t voltage, temperature;
  char voltage_s[10], temperature_s[10];
  u32 j = 0;
  uint8_t key;
  uint8_t bklt_inc = 5;


  init();							// inicjalizacja procesora

  GPIO_SetBits(LED_PORT, LED1);		// LED1 OFF
  GPIO_SetBits(LED_PORT, LED2);		// LED2 OFF
  stan_led1=0;
  stan_led2=0;



  send_str("\n\r********************************");
  send_str("\n\r******* DEMO BOARD *************");
  send_str("\n\r********************************");

  LcdFillLine(1);
  LcdGotoXY(1,1);
  LcdStr(FONT_1X,FONT_NEGATIVE,"   LCD DEMO   ");

  LcdFillLine(6);
  LcdGotoXY(1,6);
  LcdStr(FONT_1X,FONT_NEGATIVE,"   LCD DEMO   ");

  while (1)							// petla
  {
	IWDG_ReloadCounter();							// reset watchdoga
	i++;
	j = GPIOB->ODR;
	key=getkey();
	voltage=ADCVal[0];
	temperature=ADCVal[1];
	if(TIM1->CNT > TIM1->CCR1)
		TIM1->CCR1 = voltage;

	if((TDelay%500) == 0)			// co pol sekundy
	{
		LcdGotoXY(1,4);
		sprintf(voltage_s,"ADC=%04u", voltage);
		LcdStr(FONT_1X,FONT_POSITIVE,voltage_s);
		LcdGotoXY(1,5);
		sprintf(voltage_s,"V=%01.3fV", ((float)voltage / 4096) * 3.3);
		LcdStr(FONT_1X,FONT_POSITIVE,voltage_s);
		sprintf(temperature_s," %02.1fC", (1430 - (float)temperature * 0.805) / 4.3 + 25);
		LcdStr(FONT_1X,FONT_POSITIVE,temperature_s);
	}




/*	if(GPIO_ReadInputDataBit(JOY_PORT,JOY_R) == 0)	// nacisnieto przycisk ->
	{
		while(GPIO_ReadInputDataBit(JOY_PORT,JOY_R) == 0) ;
		delay_ms(50);
		if(stan_led2==1)
			{stan_led2=0; GPIO_SetBits(LED_PORT,LED2);}
		else
			{stan_led2=1; GPIO_ResetBits(LED_PORT,LED2);}

	}
*/

	if(key==KEY_UP)
	{
		send_str("\n\rKEY_UP PRESSED");
		LcdClearLine(2);
		LcdClearLine(3);
		LcdGotoXY(2,3);
		LcdStr(FONT_2X,FONT_POSITIVE,"UP");
	}
	if(key==KEY_DN)
	{
		send_str("\n\rKEY_DN PRESSED");
		LcdClearLine(2);
		LcdClearLine(3);
		LcdGotoXY(2,3);
		LcdStr(FONT_2X,FONT_POSITIVE,"DN");

	}
	if(key==KEY_L)
	{
		send_str("\n\rKEY_L PRESSED");
		LcdClearLine(2);
		LcdClearLine(3);
		LcdGotoXY(2,3);
		LcdStr(FONT_2X,FONT_POSITIVE,"LEFT");

	}
	if(key==KEY_R)
	{
		send_str("\n\rKEY_R PRESSED");
		LcdClearLine(2);
		LcdClearLine(3);
		LcdGotoXY(2,3);
		LcdStr(FONT_2X,FONT_POSITIVE,"RIGHT");

	}

	if(key==KEY_OK)
	{
		graphic_menu();
/*		send_str("\n\rKEY_OK PRESSED");
		sprintf(voltage_s," V=%01.3fV", ((float)voltage / 4096) * 3.3);
		send_str(voltage_s);
		sprintf(temperature_s," t=%02.1fC", (1430 - (float)temperature * 0.805) / 4.3 + 25);
		send_str(temperature_s);
		LcdClearLine(2);
		LcdClearLine(3);
		LcdGotoXY(2,3);
		LcdStr(FONT_2X,FONT_POSITIVE,"OK");
*/
	}



//	GPIO_SetBits(LED_PORT,LED1);
//	delay_ms(500);
//	GPIO_ResetBits(LED_PORT,LED1);
//	delay_ms(500);
  }
}

/***********************************************************************/
/* Inicjalizacja procesora *********************************************/
/***********************************************************************/

void init(void)
{
  RCC_Conf();										// inicjalizacja zegara
  NVIC_Conf();										// inicjalizacja kontrolera przerwan
  GPIO_Conf();										// inicjalizacja portow
  SysTick_Conf();									// inicjalizacja zegara SysTick (1ms)
  LCDInit();
  Tim_Conf();										// inicjalizacja timerow
  DMA_Conf();
  ADC_Conf();
//  EXTI_Conf();										// konfiguracja przerwan zewnetrznych
  USART_Conf();

//  IWDG_WriteAccessCmd(IWDG_WriteAccess_Enable);		// konfiguracja watchdoga
//  IWDG_SetPrescaler(IWDG_Prescaler_256);			// 40KHz(LSI) / 256 = 156Hz Hz
//  IWDG_SetReload(312);								// timeout watchdoga ok 2sek
//  IWDG_ReloadCounter();
//  IWDG_Enable();

}

/***********************************************************************/
/* Inicjalizacja przerwan zewnetrznych *********************************/
/***********************************************************************/
void EXTI_Conf(void)
{
  	EXTI_InitTypeDef EXTI_InitStructure;

  	GPIO_EXTILineConfig(GPIO_PortSourceGPIOB, GPIO_PinSource5);	// Poinformowanie uC o zrodle przerwania

  	EXTI_InitStructure.EXTI_Line = EXTI_Line5;					//bo nozka 5 portu
  	EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
  	EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;
  	EXTI_InitStructure.EXTI_LineCmd = ENABLE;
  	EXTI_Init(&EXTI_InitStructure);
}

/***********************************************************************/
/* Inicjalizacja kontrolera przerwan ***********************************/
/***********************************************************************/
void NVIC_Conf(void)
{
  	NVIC_InitTypeDef NVIC_InitStructure;

#ifdef  VECT_TAB_RAM
  	NVIC_SetVectorTable(NVIC_VectTab_RAM, 0x0);
#else
  	NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);
#endif

  	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);				// Grupa priorytetow

  	NVIC_InitStructure.NVIC_IRQChannel = EXTI9_5_IRQn;			// linie od IRQ 5 do 9
  	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;				// Wlacz przerwanie
  	NVIC_Init(&NVIC_InitStructure);
  	//
  	// Wlacz przerwanie od TIM1 (Capture)
  	NVIC_InitStructure.NVIC_IRQChannel = TIM1_CC_IRQn;
  	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
  	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  	NVIC_Init(&NVIC_InitStructure);
  	// Wlacz przerwanie od TIM1 (Update)
  	NVIC_InitStructure.NVIC_IRQChannel = TIM1_UP_IRQn;
  	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
  	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  	NVIC_Init(&NVIC_InitStructure);
    /* Enable the USARTx Interrupt */
    NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
}

/***********************************************************************/
/* Inicjalizacja zegara procesora **************************************/
/***********************************************************************/
void RCC_Conf(void)
{
  	ErrorStatus HSEStartUpStatus;

  	RCC_DeInit();											// Reset ustawien RCC
  	RCC_HSEConfig(RCC_HSE_ON);								// Wlacz HSE
  	HSEStartUpStatus = RCC_WaitForHSEStartUp();				// Czekaj az HSE bedzie gotowy
  	if(HSEStartUpStatus == SUCCESS)
  		{
    	FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);
    	FLASH_SetLatency(FLASH_Latency_2);					// zwloka dla pamieci Flash
   		RCC_HCLKConfig(RCC_SYSCLK_Div1);					// HCLK = SYSCLK
    	RCC_PCLK2Config(RCC_HCLK_Div1);						// PCLK2 = HCLK
    	RCC_PCLK1Config(RCC_HCLK_Div2);						// PCLK1 = HCLK/2
    	RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9);// PLLCLK = 8MHz * 9 = 72 MHz
    	RCC_PLLCmd(ENABLE);									// Wlacz PLL
    	while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET);	// Czekaj az PLL poprawnie sie uruchomi
    	RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);			// PLL bedzie zrodlem sygnalu zegarowego
    	while(RCC_GetSYSCLKSource() != 0x08);				// Czekaj az PLL bedzie sygnalem zegarowym systemu
  	}
    RCC_ADCCLKConfig(RCC_PCLK2_Div2);						// konfiguracja zegara dla ADC
     RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE);		// zalaczenie zegara dla DMA
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1 | RCC_APB2Periph_USART1 | RCC_APB2Periph_TIM1 | RCC_APB2Periph_GPIOB | RCC_APB2Periph_GPIOC | RCC_APB2Periph_GPIOA | RCC_APB2Periph_AFIO, ENABLE);	//					funcji alternatywnych portow GPIO
}

/***********************************************************************/
/* Inicjalizacja zegara SysTick (1ms) **********************************/
/***********************************************************************/
void SysTick_Conf(void)
{
	SysTick_CLKSourceConfig(SysTick_CLKSource_HCLK_Div8);
	if (SysTick_Config(SystemCoreClock / 1000))
	{
		while(1)   IWDG_ReloadCounter();		// W razie bledu petla nieskonczona
	}

}

/***********************************************************************/
/* Inicjalizacja timerow ***********************************************/
/***********************************************************************/
void Tim_Conf(void)
{
	// Ustawienia ukladu podstawy czasu
	TIM_TimeBaseStructure.TIM_Period = 4096;
	TIM_TimeBaseStructure.TIM_Prescaler = 200;  //fclk = 72MHz/250 = 288kHz
	TIM_TimeBaseStructure.TIM_ClockDivision = 0;
	TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;

	TIM_TimeBaseInit(TIM1, &TIM_TimeBaseStructure);

	// Konfiguracja kanalu 1
	TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1;
	TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
	TIM_OCInitStructure.TIM_Pulse = bklt_level;
	TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High;
	TIM_OC1Init(TIM1, &TIM_OCInitStructure);

	TIM_OC1PreloadConfig(TIM1, TIM_OCPreload_Disable);

	// Wlaczenie przerwan od kanalow
  	TIM_ITConfig(TIM1, TIM_IT_CC1 | TIM_IT_Update, ENABLE);

  	// Wlaczenie timera
  	TIM_Cmd(TIM1, ENABLE);
}

/***********************************************************************/
/* Inicjalizacja portow ************************************************/
/***********************************************************************/
void GPIO_Conf(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

	GPIO_InitStructure.GPIO_Pin =  LED1 | LED2;		// LED1 i 2 jako wyjscia Open-Drain
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_OD;	//
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;	//
	GPIO_Init(GPIOB, &GPIO_InitStructure);			//

	GPIO_InitStructure.GPIO_Pin =  JOY_OK;				// JOY_OK jako wejscie floating (tez na porcie GPIOB)
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;	//
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;		//
	GPIO_Init(GPIOB, &GPIO_InitStructure);				//

	GPIO_InitStructure.GPIO_Pin =  JOY_U | JOY_D | JOY_L | JOY_R;	//JOY_U,D,L,R jako wejscia floating na porcie GPIOC
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;			//
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;				//
	GPIO_Init(GPIOC, &GPIO_InitStructure);						//

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;				// wejscie od potencjometru
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;			// jako we do ADC
	GPIO_Init(GPIOB, &GPIO_InitStructure);					//

	// Konfiguracja PA9 jako Tx
  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  	GPIO_Init(GPIOA, &GPIO_InitStructure);

  	// Konfiguracja PA10 jako Rx
  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  	GPIO_Init(GPIOA, &GPIO_InitStructure);

  	GPIO_InitStructure.GPIO_Pin = CLK | DATA | DC | RES | SCE | LCD_BKLT | LCD_PWR;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  	GPIO_Init(GPIOA, &GPIO_InitStructure);

}

/***********************************************************************/
/* Inicjalizacja ADC ***************************************************/
/***********************************************************************/
void ADC_Conf(void)
{
	ADC_InitStructure.ADC_Mode = ADC_Mode_Independent;
	ADC_InitStructure.ADC_ScanConvMode = ENABLE;
	ADC_InitStructure.ADC_ContinuousConvMode = ENABLE;
	ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_None;
	ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;
	ADC_InitStructure.ADC_NbrOfChannel = 2;
	ADC_Init(ADC1, &ADC_InitStructure);

	// kanal 8 (PB.0)
	ADC_RegularChannelConfig(ADC1, ADC_Channel_8, 1, ADC_SampleTime_1Cycles5);
	ADC_DMACmd(ADC1, ENABLE);						// zalacz DMA dla ADC1
	ADC_Cmd(ADC1, ENABLE);							// zalacz ADC1

	ADC_RegularChannelConfig(ADC1, ADC_Channel_16, 2, ADC_SampleTime_239Cycles5);

	// Wlaczenie czujnika temperatury
  	ADC_TempSensorVrefintCmd(ENABLE);

	ADC_ResetCalibration(ADC1);						// reset kalibracji ADC1
	while(ADC_GetResetCalibrationStatus(ADC1));		// czekanie na koniec resetu kalibracji ADC1

	ADC_StartCalibration(ADC1);						// start kalibracji ADC1
	while(ADC_GetCalibrationStatus(ADC1));			// czekanie na koniec kalibracji ADC1

	ADC_SoftwareStartConvCmd(ADC1, ENABLE);			// zalaczenie pierwszej konwersji ADC1
}

/***********************************************************************/
/* Inicjalizacja DMA ***************************************************/
/***********************************************************************/
void DMA_Conf(void)
{

	DMA_DeInit(DMA1_Channel1);
//	DMA_InitStructure.DMA_PeripheralBaseAddr = (uint32_t)TIM1_CCR1_Address;	// ADC1 -> PWM bezposrednio
//	DMA_InitStructure.DMA_MemoryBaseAddr = (uint32_t)ADC1_DR_Address;		//
//	DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralDST;						//
	DMA_InitStructure.DMA_PeripheralBaseAddr = ADC1_DR_Address;
	DMA_InitStructure.DMA_MemoryBaseAddr = (u32)&ADCVal;
	// Kierunek: zrodlem jest ADC
	DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralSRC;

	DMA_InitStructure.DMA_BufferSize = 2;									// rozmiar danych
	DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
	DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;
	DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord;	// 16 bitow
	DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord;			//
	DMA_InitStructure.DMA_Mode = DMA_Mode_Circular;
	DMA_InitStructure.DMA_Priority = DMA_Priority_High;
	DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;
	DMA_Init(DMA1_Channel1, &DMA_InitStructure);

	DMA_Cmd(DMA1_Channel1, ENABLE);											// zalaczenie DMA
}
void USART_Conf(void)
{
	USART_InitTypeDef USART_InitStructure;

	USART_InitStructure.USART_BaudRate = 9600;
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No;
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	USART_Init(USART1, &USART_InitStructure);

	 /* Enable the EVAL_COM1 Transmoit interrupt: this interrupt is generated when the
	     EVAL_COM1 transmit data register is empty */
//	USART_ITConfig(USART1, USART_IT_TXE, ENABLE);

	  /* Enable the EVAL_COM1 Receive interrupt: this interrupt is generated when the
	     EVAL_COM1 receive data register is not empty */
	USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);

	USART_Cmd(USART1, ENABLE);

}

int getkey(void)
{
	uint8_t key=NO_KEY;

	IWDG_ReloadCounter();							// reset watchdoga
	if(GPIO_ReadInputDataBit(JOY_PORT,JOY_U) == 0)	// nacisnieto przycisk UP
		{
			if(inc==increment_delay)				// przycisk jest "przytrzymywany"
				delay_ms(auto_repeat_period);						// czestotliwosc "autopowtarzania" przycisku
			while((GPIO_ReadInputDataBit(JOY_PORT,JOY_U) == 0) && (inc<increment_delay)) if(inc<increment_delay) inc++;
			delay_ms(50);
			key=KEY_UP;
		}
	else if(GPIO_ReadInputDataBit(JOY_PORT,JOY_D) == 0)	// nacisnieto przycisk DN
		{
			if(inc==increment_delay)
				delay_ms(auto_repeat_period);
			while((GPIO_ReadInputDataBit(JOY_PORT,JOY_D) == 0)&& (inc<increment_delay)) if(inc<increment_delay) inc++;
			delay_ms(50);
			key=KEY_DN;
		}
	else if(GPIO_ReadInputDataBit(JOY_PORT,JOY_L) == 0)	// nacisnieto przycisk LEFT
		{
			if(inc==increment_delay)
				delay_ms(auto_repeat_period);
			while((GPIO_ReadInputDataBit(JOY_PORT,JOY_L) == 0)&& (inc<increment_delay)) if(inc<increment_delay) inc++;
			delay_ms(50);
			key=KEY_L;
		}
	else if(GPIO_ReadInputDataBit(JOY_PORT,JOY_R) == 0)	// nacisnieto przycisk RIGHT
		{
			if(inc==increment_delay)
				delay_ms(auto_repeat_period);
			while((GPIO_ReadInputDataBit(JOY_PORT,JOY_R) == 0)&& (inc<increment_delay)) if(inc<increment_delay) inc++;
			delay_ms(50);
			key=KEY_R;
		}
	else if(GPIO_ReadInputDataBit(LED_PORT,JOY_OK) == 0)	// nacisnieto przycisk OK
		{
			while(GPIO_ReadInputDataBit(LED_PORT,JOY_OK) == 0) ;
			delay_ms(50);
			key=KEY_OK;
		}
	else
	{
		key=NO_KEY;
		inc=0;
	}
	return(key);
}


/***********************************************************************/
/* Opoznienie **********************************************************/
/***********************************************************************/
void delay_ms(uint32_t time)
{
//////////////////////// wersja oparta na petlach ////////////////////
/*    volatile u32 i=0;
    volatile u32 j=0;
    for(i=0;i<time*8;i++)
    {
        for(j=0;j<560;j++)
        {
            asm volatile("nop");

        }
    }
*/
///////////////////// wersja oparta na zegarze SysTick (co 1ms) ////////////
	volatile uint32_t old_sys_tick, count;
	count=0;
	do
	{
		old_sys_tick = TDelay;
		while(old_sys_tick == TDelay) IWDG_ReloadCounter();
		count++;
		IWDG_ReloadCounter();						// reset watchdoga
	}while(count<time);
}

void send_str(uint8_t *str)
{
	 do
	 {
		 USART_SendData(USART1,*str);
		 while (USART_GetFlagStatus(USART1, USART_FLAG_TC) == RESET);
	 }while (*str++);

}

void send_chr(uint8_t chr)
{
		 USART_SendData(USART1,chr);
		 while (USART_GetFlagStatus(USART1, USART_FLAG_TC) == RESET);
}

